Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2231)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 2232)
@@ -1230,8 +1341,12 @@
     DO  i = nxl, nxr
        DO  j = nysv, nyn
-          DO  k = nzb_v_inner(j,i)+1, nzt
-             v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
-                                               tsc(3) * tv_m(k,j,i) )          &
-                                   - tsc(5) * rdf(k) * ( v(k,j,i) - v_init(k) )
+          DO  k = nzb+1, nzt
+             v_p(k,j,i) = v(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) +        &
+                                                 tsc(3) * tv_m(k,j,i) )        &
+                                               - tsc(5) * rdf(k) *             &
+                                                      ( v(k,j,i) - v_init(k) ) &
+                                     ) * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 2 )&
+                                              )
           ENDDO
        ENDDO
@@ -1244,5 +1359,5 @@
           DO  i = nxl, nxr
              DO  j = nysv, nyn
-                DO  k = nzb_v_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
                    tv_m(k,j,i) = tend(k,j,i)
                 ENDDO
@@ -1253,6 +1368,7 @@
           DO  i = nxl, nxr
              DO  j = nysv, nyn
-                DO  k = nzb_v_inner(j,i)+1, nzt
-                   tv_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tv_m(k,j,i)
+                DO  k = nzb+1, nzt
+                   tv_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                    &
+                                  + 5.3125_wp * tv_m(k,j,i)
                 ENDDO
              ENDDO
@@ -1306,8 +1422,11 @@
     DO  i = nxl, nxr
        DO  j = nys, nyn
-          DO  k = nzb_w_inner(j,i)+1, nzt-1
-             w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
-                                               tsc(3) * tw_m(k,j,i) )          &
-                                   - tsc(5) * rdf(k) * w(k,j,i)
+          DO  k = nzb+1, nzt-1
+             w_p(k,j,i) = w(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) +        &
+                                                 tsc(3) * tw_m(k,j,i) )        &
+                                               - tsc(5) * rdf(k) * w(k,j,i)    &
+                                     ) * MERGE( 1.0_wp, 0.0_wp,                &
+                                                BTEST( wall_flags_0(k,j,i), 3 )&
+                                              )
           ENDDO
        ENDDO
@@ -1320,5 +1439,5 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_w_inner(j,i)+1, nzt-1
+                DO  k = nzb+1, nzt-1
                    tw_m(k,j,i) = tend(k,j,i)
                 ENDDO
@@ -1329,6 +1448,7 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_w_inner(j,i)+1, nzt-1
-                   tw_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tw_m(k,j,i)
+                DO  k = nzb+1, nzt-1
+                   tw_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                    &
+                                  + 5.3125_wp * tw_m(k,j,i)
                 ENDDO
              ENDDO
@@ -1376,12 +1496,14 @@
        ENDIF
 
-       CALL diffusion_s( pt, shf, tswst, wall_heatflux )
-
-!
-!--    Tendency pt from wall heat flux from urban surface
-       IF ( urban_surface )  THEN
-          CALL usm_wall_heat_flux
-       ENDIF
-
+       CALL diffusion_s( pt,                                                   &
+                         surf_def_h(0)%shf, surf_def_h(1)%shf,                 &
+                         surf_def_h(2)%shf,                                    &
+                         surf_lsm_h%shf,    surf_usm_h%shf,                    &
+                         surf_def_v(0)%shf, surf_def_v(1)%shf,                 &
+                         surf_def_v(2)%shf, surf_def_v(3)%shf,                 &
+                         surf_lsm_v(0)%shf, surf_lsm_v(1)%shf,                 &
+                         surf_lsm_v(2)%shf, surf_lsm_v(3)%shf,                 &
+                         surf_usm_v(0)%shf, surf_usm_v(1)%shf,                 &
+                         surf_usm_v(2)%shf, surf_usm_v(3)%shf )
 !
 !--    If required compute heating/cooling due to long wave radiation processes
@@ -1426,9 +1548,14 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
-                                                    tsc(3) * tpt_m(k,j,i) )    &
-                                        - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
-                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
+             DO  k = nzb+1, nzt
+                pt_p(k,j,i) = pt(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +      &
+                                                   tsc(3) * tpt_m(k,j,i) )     &
+                                                 - tsc(5) *                    &
+                                                   ( pt(k,j,i) - pt_init(k) ) *&
+                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )&
+                                          )                                    &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
              ENDDO
           ENDDO
@@ -1441,5 +1568,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tpt_m(k,j,i) = tend(k,j,i)
                    ENDDO
@@ -1450,7 +1577,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tpt_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                      5.3125_wp * tpt_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tpt_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
+                                        5.3125_wp * tpt_m(k,j,i)
                    ENDDO
                 ENDDO
@@ -1499,5 +1626,14 @@
        ENDIF
 
-       CALL diffusion_s( sa, saswsb, saswst, wall_salinityflux )
+       CALL diffusion_s( sa,                                                   &
+                         surf_def_h(0)%sasws, surf_def_h(1)%sasws,             &
+                         surf_def_h(2)%sasws,                                  &
+                         surf_lsm_h%sasws,    surf_usm_h%sasws,                &
+                         surf_def_v(0)%sasws, surf_def_v(1)%sasws,             &
+                         surf_def_v(2)%sasws, surf_def_v(3)%sasws,             &
+                         surf_lsm_v(0)%sasws, surf_lsm_v(1)%sasws,             &
+                         surf_lsm_v(2)%sasws, surf_lsm_v(3)%sasws,             &
+                         surf_usm_v(0)%sasws, surf_usm_v(1)%sasws,             &
+                         surf_usm_v(2)%sasws, surf_usm_v(3)%sasws )
 
        CALL user_actions( 'sa-tendency' )
@@ -1507,9 +1643,13 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
-                                                    tsc(3) * tsa_m(k,j,i) )    &
-                                        - tsc(5) * rdf_sc(k) *                 &
-                                          ( sa(k,j,i) - sa_init(k) )
+             DO  k = nzb+1, nzt
+                sa_p(k,j,i) = sa(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +      &
+                                                   tsc(3) * tsa_m(k,j,i) )     &
+                                                 - tsc(5) * rdf_sc(k) *        &
+                                                 ( sa(k,j,i) - sa_init(k) )    &
+                                          )                                    &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                 IF ( sa_p(k,j,i) < 0.0_wp )  sa_p(k,j,i) = 0.1_wp * sa(k,j,i)
              ENDDO
@@ -1523,5 +1663,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tsa_m(k,j,i) = tend(k,j,i)
                    ENDDO
@@ -1532,7 +1672,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tsa_m(k,j,i) = -9.5625_wp * tend(k,j,i) + &
-                                      5.3125_wp * tsa_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tsa_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +              &
+                                        5.3125_wp * tsa_m(k,j,i)
                    ENDDO
                 ENDDO
@@ -1587,5 +1727,14 @@
        ENDIF
 
-       CALL diffusion_s( q, qsws, qswst, wall_qflux )
+       CALL diffusion_s( q,                                                    &
+                         surf_def_h(0)%qsws, surf_def_h(1)%qsws,               &
+                         surf_def_h(2)%qsws,                                   &
+                         surf_lsm_h%qsws,    surf_usm_h%qsws,                  &
+                         surf_def_v(0)%qsws, surf_def_v(1)%qsws,               &
+                         surf_def_v(2)%qsws, surf_def_v(3)%qsws,               &
+                         surf_lsm_v(0)%qsws, surf_lsm_v(1)%qsws,               &
+                         surf_lsm_v(2)%qsws, surf_lsm_v(3)%qsws,               &
+                         surf_usm_v(0)%qsws, surf_usm_v(1)%qsws,               &
+                         surf_usm_v(2)%qsws, surf_usm_v(3)%qsws )
 
 !
@@ -1616,9 +1765,12 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i) = q(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
-                                                  tsc(3) * tq_m(k,j,i) )       &
-                                      - tsc(5) * rdf_sc(k) *                   &
-                                        ( q(k,j,i) - q_init(k) )
+             DO  k = nzb+1, nzt
+                q_p(k,j,i) = q(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +        &
+                                                 tsc(3) * tq_m(k,j,i) )        &
+                                               - tsc(5) * rdf_sc(k) *          &
+                                                      ( q(k,j,i) - q_init(k) ) &
+                                        ) * MERGE( 1.0_wp, 0.0_wp,             &
+                                                   BTEST( wall_flags_0(k,j,i), 0 ) &
+                                                 )
                 IF ( q_p(k,j,i) < 0.0_wp )  q_p(k,j,i) = 0.1_wp * q(k,j,i)
              ENDDO
@@ -1632,5 +1784,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tq_m(k,j,i) = tend(k,j,i)
                    ENDDO
@@ -1641,6 +1793,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      tq_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tq_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      tq_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                 &
+                                     + 5.3125_wp * tq_m(k,j,i)
                    ENDDO
                 ENDDO
@@ -1688,5 +1841,14 @@
           ENDIF
 
-          CALL diffusion_s( qr, qrsws, qrswst, wall_qrflux )
+          CALL diffusion_s( qr,                                                &
+                            surf_def_h(0)%qrsws, surf_def_h(1)%qrsws,          &
+                            surf_def_h(2)%qrsws,                               &
+                            surf_lsm_h%qrsws,    surf_usm_h%qrsws,             &
+                            surf_def_v(0)%qrsws, surf_def_v(1)%qrsws,          &
+                            surf_def_v(2)%qrsws, surf_def_v(3)%qrsws,          &
+                            surf_lsm_v(0)%qrsws, surf_lsm_v(1)%qrsws,          &
+                            surf_lsm_v(2)%qrsws, surf_lsm_v(3)%qrsws,          &
+                            surf_usm_v(0)%qrsws, surf_usm_v(1)%qrsws,          &
+                            surf_usm_v(2)%qrsws, surf_usm_v(3)%qrsws )
 
 !
@@ -1694,8 +1856,13 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   qr_p(k,j,i) = qr(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +     &
-                                                     tsc(3) * tqr_m(k,j,i) )   &
-                                           - tsc(5) * rdf_sc(k) * qr(k,j,i)
+                DO  k = nzb+1, nzt
+                   qr_p(k,j,i) = qr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
+                                                      tsc(3) * tqr_m(k,j,i) )  &
+                                                    - tsc(5) * rdf_sc(k) *     &
+                                                               qr(k,j,i)       &
+                                             )                                 &
+                                    * MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                    IF ( qr_p(k,j,i) < 0.0_wp )  qr_p(k,j,i) = 0.0_wp
                 ENDDO
@@ -1709,5 +1876,5 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_s_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tqr_m(k,j,i) = tend(k,j,i)
                       ENDDO
@@ -1718,7 +1885,7 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_s_inner(j,i)+1, nzt
-                         tqr_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * &
-                                                                   tqr_m(k,j,i)
+                      DO  k = nzb+1, nzt
+                         tqr_m(k,j,i) =   -9.5625_wp * tend(k,j,i)             &
+                                         + 5.3125_wp * tqr_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -1760,5 +1927,14 @@
           ENDIF
 
-          CALL diffusion_s( nr, nrsws, nrswst, wall_nrflux )
+          CALL diffusion_s( nr,                                                &
+                            surf_def_h(0)%nrsws, surf_def_h(1)%nrsws,          &
+                            surf_def_h(2)%nrsws,                               &
+                            surf_lsm_h%nrsws,    surf_usm_h%nrsws,             & 
+                            surf_def_v(0)%nrsws, surf_def_v(1)%nrsws,          &
+                            surf_def_v(2)%nrsws, surf_def_v(3)%nrsws,          &
+                            surf_lsm_v(0)%nrsws, surf_lsm_v(1)%nrsws,          &
+                            surf_lsm_v(2)%nrsws, surf_lsm_v(3)%nrsws,          &
+                            surf_usm_v(0)%nrsws, surf_usm_v(1)%nrsws,          &
+                            surf_usm_v(2)%nrsws, surf_usm_v(3)%nrsws )
 
 !
@@ -1766,8 +1942,13 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
-                   nr_p(k,j,i) = nr(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +     &
-                                                     tsc(3) * tnr_m(k,j,i) )   &
-                                           - tsc(5) * rdf_sc(k) * nr(k,j,i)
+                DO  k = nzb+1, nzt
+                   nr_p(k,j,i) = nr(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +   &
+                                                      tsc(3) * tnr_m(k,j,i) )  &
+                                                    - tsc(5) * rdf_sc(k) *     &
+                                                               nr(k,j,i)       &
+                                             )                                 &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                    IF ( nr_p(k,j,i) < 0.0_wp )  nr_p(k,j,i) = 0.0_wp
                 ENDDO
@@ -1781,5 +1962,5 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_s_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tnr_m(k,j,i) = tend(k,j,i)
                       ENDDO
@@ -1790,7 +1971,7 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_s_inner(j,i)+1, nzt
-                         tnr_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * &
-                                                                   tnr_m(k,j,i)
+                      DO  k = nzb+1, nzt
+                         tnr_m(k,j,i) =  -9.5625_wp * tend(k,j,i)             &
+                                         + 5.3125_wp * tnr_m(k,j,i)
                       ENDDO
                    ENDDO
@@ -1840,5 +2021,14 @@
        ENDIF
 
-       CALL diffusion_s( s, ssws, sswst, wall_sflux )
+       CALL diffusion_s( s,                                                    &
+                         surf_def_h(0)%ssws, surf_def_h(1)%ssws,               &
+                         surf_def_h(2)%ssws,                                   &
+                         surf_lsm_h%ssws,    surf_usm_h%ssws,                  &
+                         surf_def_v(0)%ssws, surf_def_v(1)%ssws,               &
+                         surf_def_v(2)%ssws, surf_def_v(3)%ssws,               &
+                         surf_lsm_v(0)%ssws, surf_lsm_v(1)%ssws,               &
+                         surf_lsm_v(2)%ssws, surf_lsm_v(3)%ssws,               &
+                         surf_usm_v(0)%ssws, surf_usm_v(1)%ssws,               &
+                         surf_usm_v(2)%ssws, surf_usm_v(3)%ssws )
 
 !
@@ -1871,9 +2061,13 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                s_p(k,j,i) = s(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
-                                                  tsc(3) * ts_m(k,j,i) )       &
-                                      - tsc(5) * rdf_sc(k) *                   &
-                                        ( s(k,j,i) - s_init(k) )
+             DO  k = nzb+1, nzt
+                s_p(k,j,i) = s(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +        &
+                                                 tsc(3) * ts_m(k,j,i) )        &
+                                               - tsc(5) * rdf_sc(k) *          &
+                                                    ( s(k,j,i) - s_init(k) )   &
+                                        )                                      &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                 IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
              ENDDO
@@ -1887,5 +2081,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       ts_m(k,j,i) = tend(k,j,i)
                    ENDDO
@@ -1896,6 +2090,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      ts_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * ts_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      ts_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                 &
+                                     + 5.3125_wp * ts_m(k,j,i)
                    ENDDO
                 ENDDO
@@ -1973,7 +2168,11 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_inner(j,i)+1, nzt
-                e_p(k,j,i) = e(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
-                                                  tsc(3) * te_m(k,j,i) )
+             DO  k = nzb+1, nzt
+                e_p(k,j,i) = e(k,j,i) + ( dt_3d * ( sbt * tend(k,j,i) +        &
+                                                 tsc(3) * te_m(k,j,i) )        &
+                                        )                                      &
+                                   * MERGE( 1.0_wp, 0.0_wp,                    &
+                                             BTEST( wall_flags_0(k,j,i), 0 )   &
+                                          )
                 IF ( e_p(k,j,i) < 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
              ENDDO
@@ -1987,5 +2186,5 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       te_m(k,j,i) = tend(k,j,i)
                    ENDDO
@@ -1996,6 +2195,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt
-                      te_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * te_m(k,j,i)
+                   DO  k = nzb+1, nzt
+                      te_m(k,j,i) =   -9.5625_wp * tend(k,j,i)                 &
+                                     + 5.3125_wp * te_m(k,j,i)
                    ENDDO
                 ENDDO
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
+! Bugfix in read restart
 ! 
 ! Former revisions:
@@ -147,5 +148,6 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb_s_inner, nzb, nzt
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,           &
+               wall_flags_0
 
     USE kinds
@@ -1160,5 +1162,11 @@
        DO i = nxlg, nxrg
           DO j = nysg, nyng
-             k = nzb_s_inner(j,i)
+!
+!--          Obtain vertical index of topography top 
+             k = MAXLOC(                                                       &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(:,j,i), 12 )                &
+                             ), DIM = 1                                        &
+                       ) - 1
 
              exn1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
@@ -1210,5 +1218,11 @@
        DO i = nxlg, nxrg
           DO j = nysg, nyng
-             k = nzb_s_inner(j,i)
+!
+!--          Obtain vertical index of topography top. So far it is identical to nzb.
+             k = MAXLOC(                                                       &
+                        MERGE( 1, 0,                                           &
+                               BTEST( wall_flags_0(:,j,i), 12 )                &
+                             ), DIM = 1                                        &
+                       ) - 1
 
              rad_net(j,i)      = net_radiation
